# To-Array

------

A simple tool to convert text or binary files into C strings and arrays, including some optional minimization (for text files). This is the tool I often use to embed shaders and binary data into my programs. The minimization is basic and removes spaces, tabs and comments.

## Usage

```C:\> toArray.exe inputFile outputFile {Text_To_Text|Text_To_CString|Text_To_CArray|Binary_To_CArray} [minify]```

* minify is optional
* Text_To_Text takes a text file and spits out a text file. Useful for minimization
* Text_To_CString takes a text file and produces a C char *data string
* Text_To_CArray takes a text file and produces a C unsigned char data[] array
* Binary_To_CArray takes a binary file and produces a C unsigned char data[] array


## Requirements

Any C(++) compiler will do, no dependencies. I provide a Visual Studio 2019 solution for convenience, but the project consists of 3 C(++) files without external dependencies or modern C++, so it's pretty to build on any platform you want.

## License

[WTFPL license](https://en.wikipedia.org/wiki/WTFPL)

## Credits

[Inigo Quilez](https://iquilezles.org)


