#include <stdio.h>
#include <string.h>
#include <malloc.h>

size_t utlGetFileLength( FILE *fp )
{
    fseek(fp, 0, SEEK_END);
  //size_t res = _ftelli64( fp ); // on windows ftell is 32 by default
    size_t res = ftell(fp);
    fseek(fp, 0, SEEK_SET);
    return res;
}

char * utlReadAll( const char *inFilename, size_t *outLen )
{
    FILE *fp = fopen(inFilename, "rb");
    if( !fp )
	    return nullptr;

    const size_t len = utlGetFileLength(fp);

	char *buffer = (char*)malloc( len+1 );
	if( !buffer ) { fclose(fp); return 0; };

    fread( buffer, 1, len, fp );
	buffer[len] = 0;

	fclose( fp );

    *outLen = len;

	return buffer;
}

void utlRemoveOccurrences( char *str, const char what )
{
    int wptr = 0;
    for( int i=0; ; i++ )
    {
        const char c = str[i];
        if( c==0 ) break;
        if (c != what) str[wptr++] = c;
    }
    str[wptr] = 0;
}

static bool is_slash( char c )
{
    return (c=='/') || (c=='\\');
}

static char *iExtractName( const char *file )
{
	// detect the last slash symbol
	int l = -1;
	for( int i=0; file[i]; i++ )
		if( is_slash( file[i] ) )
			l = i;

	// if no slash found, return file
	char *res = nullptr;
    size_t nl = 0;
	if( l==-1 )
	{
        nl = strlen(file);
		res = (char*)malloc( (nl+1)*sizeof(char) );
		if( !res )
			return nullptr;
        strncpy( res, file, nl );
	}
	else
	{
        nl = strlen(file)-l;
		res = (char*)malloc( (nl+1)*sizeof(char) );
		if( !res )
			return nullptr;
        strncpy( res, file+l+1, nl );
	}

	return res;
}

char *utlExtractNameWithoutExtension( const char *file )
{
	char *res = iExtractName( file );
	int l = -1;
	for( int i=0; res[i]; i++ ) if( res[i]=='.' ) l = i;
    if( l!=-1 ) res[l] = 0;
	return res;
}
